diff -urN ../sys/dev/ic/midwayvar.h ./dev/ic/midwayvar.h
--- ../sys/dev/ic/midwayvar.h	Fri Mar 21 07:03:05 1997
+++ ./dev/ic/midwayvar.h	Thu Jun 21 17:56:38 2001
@@ -1,4 +1,4 @@
-/*	$OpenBSD: midwayvar.h,v 1.9 1997/03/20 22:03:05 chuck Exp $	*/
+/*	$NetBSD: midwayvar.h,v 1.9 1997/03/11 23:30:21 chuck Exp $	*/
 
 /*
  *
@@ -90,6 +90,16 @@
 
 #endif
 
+#if 1 /* for ATM_PVCEXT */
+#include <sys/queue.h>
+
+/* round-robin scheduler */
+struct rrp {
+	struct rrp *next;
+	struct ifnet *ifp;
+	int	nref;
+};
+#endif
 
 /*
  * softc
@@ -144,6 +154,10 @@
   u_int8_t txspeed[MID_N_VC];	/* speed of tx on a VC */
   u_int8_t txvc2slot[MID_N_VC]; /* map VC to slot */
 
+#if 1 /* for ATM_PVCEXT */
+  struct rrp *txrrp;		/* round-robin pointer to ifnet */
+#endif
+
   /* recv vc ctrl. (per vc).   maps VC number to recv slot */
   u_int16_t rxvc2slot[MID_N_VC];
   int en_nrx;			/* # of active rx slots */
@@ -162,6 +176,8 @@
     struct ifqueue q;		/* mbufs waiting for dma now */
   } rxslot[EN_MAXNRX];		/* recv info */
 
+  u_int8_t macaddr[6];		/* card unique mac address */
+
   /* stats */
   u_int32_t vtrash;		/* sw copy of counter */
   u_int32_t otrash;		/* sw copy of counter */
@@ -194,6 +210,10 @@
   u_int8_t bestburstmask;	/* bits to check if not multiple of burst */
   u_int8_t alburst;		/* align dma bursts? */
   u_int8_t is_adaptec;		/* adaptec version of midway? */
+
+#if 1 /* for ATM_PVCEXT */
+  LIST_HEAD(sif_list, pvcsif) sif_list;	/* pvc subinterface list */
+#endif
 };
 
 /*
diff -urN ../sys/dev/ic/pdq_ifsubr.c ./dev/ic/pdq_ifsubr.c
--- ../sys/dev/ic/pdq_ifsubr.c	Thu Oct 31 10:01:37 1996
+++ ./dev/ic/pdq_ifsubr.c	Thu Jun 21 17:56:38 2001
@@ -148,7 +148,7 @@
     ifp->if_timer = 0;
     for (;;) {
 	struct mbuf *m;
-	IF_DEQUEUE(&ifp->if_snd, m);
+	IFQ_DEQUEUE(&ifp->if_snd, m);
 	if (m == NULL)
 	    return;
 	m_freem(m);
@@ -160,7 +160,6 @@
     struct ifnet *ifp)
 {
     pdq_softc_t *sc = (pdq_softc_t *) ((caddr_t) ifp - offsetof(pdq_softc_t, sc_ac.ac_if));
-    struct ifqueue *ifq = &ifp->if_snd;
     struct mbuf *m;
     int tx = 0;
 
@@ -175,15 +174,16 @@
 	return;
     }
     for (;; tx = 1) {
-	IF_DEQUEUE(ifq, m);
+	IFQ_POLL(&ifp->if_snd, m);
 	if (m == NULL)
 	    break;
 
 	if (pdq_queue_transmit_data(sc->sc_pdq, m) == PDQ_FALSE) {
 	    ifp->if_flags |= IFF_OACTIVE;
-	    IF_PREPEND(ifq, m);
 	    break;
 	}
+
+	IFQ_DEQUEUE(&ifp->if_snd, m);
     }
     if (tx)
 	PDQ_DO_TYPE2_PRODUCER(sc->sc_pdq);
@@ -221,7 +221,7 @@
 {
     pdq_softc_t *sc = (pdq_softc_t *) pdq->pdq_os_ctx;
     sc->sc_if.if_flags &= ~IFF_OACTIVE;
-    if (sc->sc_if.if_snd.ifq_head != NULL) {
+    if (!IFQ_IS_EMPTY(&sc->sc_if.if_snd)) {
 	sc->sc_if.if_timer = PDQ_OS_TX_TIMEOUT;
 	pdq_ifstart(&sc->sc_if);
     } else {
@@ -374,6 +374,9 @@
     ifp->if_ioctl = pdq_ifioctl;
     ifp->if_output = fddi_output;
     ifp->if_start = pdq_ifstart;
+#ifdef notyet /* if_fddisubr.c hasn't been converted yet */
+    IFQ_SET_READY(&ifp->if_snd);
+#endif
   
     if_attach(ifp);
     fddi_ifattach(ifp);
diff -urN ../sys/dev/ic/rtl81x9.c ./dev/ic/rtl81x9.c
--- ../sys/dev/ic/rtl81x9.c	Sun Apr 15 10:18:28 2001
+++ ./dev/ic/rtl81x9.c	Thu Jun 21 18:03:16 2001
@@ -848,7 +848,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_2(sc, RL_IMR, RL_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		rl_start(ifp);
 
 	return (claimed);
@@ -915,16 +915,18 @@
 {
 	struct rl_softc		*sc;
 	struct mbuf		*m_head = NULL;
+	int			pkts = 0;
 
 	sc = ifp->if_softc;
 
 	while(RL_CUR_TXMBUF(sc) == NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
 		/* Pack the data into the descriptor. */
 		rl_encap(sc, m_head);
+		pkts++;
 
 #if NBPFILTER > 0
 		/*
@@ -945,6 +947,8 @@
 
 		RL_INC(sc->rl_cdata.cur_tx);
 	}
+	if (pkts == 0)
+		return;
 
 	/*
 	 * We broke out of the loop because all our TX slots are
@@ -1274,7 +1278,8 @@
 	ifp->if_start = rl_start;
 	ifp->if_watchdog = rl_watchdog;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	bcopy(sc->sc_dev.dv_xname, ifp->if_xname, IFNAMSIZ);
 
diff -urN ../sys/dev/ic/tropic.c ./dev/ic/tropic.c
--- ../sys/dev/ic/tropic.c	Tue Dec 28 06:51:35 1999
+++ ./dev/ic/tropic.c	Thu Jun 21 17:56:38 2001
@@ -352,6 +352,9 @@
 		ifp->if_start = tr_oldstart;
 	ifp->if_flags = IFF_BROADCAST | IFF_NOTRAILERS;
 	ifp->if_watchdog = tr_watchdog;
+#ifdef notyet /* if_tokensubr.c hasn't been converted yet */
+	IFQ_SET_READY(&ifp->if_snd);
+#endif
 
 	switch (MM_INB(sc, TR_MEDIAS_OFFSET)) {
 	case 0xF:
@@ -736,7 +739,7 @@
 		return;
 
 	/* if data in queue, copy mbuf chain to fast path buffers */
-	IF_DEQUEUE(&ifp->if_snd, m0);
+	IFQ_DEQUEUE(&ifp->if_snd, m0);
 
 	if (m0 == 0)
 		return;
@@ -802,9 +805,6 @@
 #endif
 }
 
-
-#define	IF_EMPTYQUEUE(queue) ((queue).ifq_head == 0)
-
 /*
  *  tr_intr - interrupt handler.  Find the cause of the interrupt and
  *  service it.
@@ -1043,7 +1043,7 @@
 					    sc->sc_dev.dv_xname);
 					ifp->if_flags &= ~IFF_RUNNING;
 					ifp->if_flags &= ~IFF_UP;
-					if_qflush(&ifp->if_snd);
+					IFQ_PURGE(&ifp->if_snd);
 					timeout(tr_reinit, sc ,hz*30);
 				}
 				else {
@@ -1117,7 +1117,7 @@
  * XXX should this be done here ?
  */
 				/* if data on send queue */
-				if (!IF_EMPTYQUEUE(ifp->if_snd))
+				if (!IFQ_IS_EMPTY(&ifp->if_snd))
 					tr_oldstart(ifp);
 				break;
 
@@ -1351,7 +1351,7 @@
  * XXX what's command here ?  command = 0x0d (always ?)
  */
 		/* if data in queue, copy mbuf chain to DHB */
-		IF_DEQUEUE(&ifp->if_snd, m0);
+		IFQ_DEQUEUE(&ifp->if_snd, m0);
 		if (m0 != 0) {
 #if NBPFILTER > 0
 			if (ifp->if_bpf)
diff -urN ../sys/dev/ic/xl.c ./dev/ic/xl.c
--- ../sys/dev/ic/xl.c	Mon Apr  9 02:58:44 2001
+++ ./dev/ic/xl.c	Thu Jun 21 17:56:38 2001
@@ -708,6 +708,7 @@
 {
 	struct mbuf		*m;
 	struct ifnet		*ifp;
+	int			error;
 
 	ifp = &sc->arpcom.ac_if;
 
@@ -725,7 +726,11 @@
 	mtod(m, unsigned char *)[15] = 0;
 	mtod(m, unsigned char *)[16] = 0xE3;
 	m->m_len = m->m_pkthdr.len = sizeof(struct ether_header) + 3;
-	IF_ENQUEUE(&ifp->if_snd, m);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m, NULL, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+#endif
 	xl_start(ifp);
 
 	return;
@@ -1504,7 +1509,7 @@
 		}
 	}
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		(*ifp->if_start)(ifp);
 
 	return (claimed);
@@ -1666,7 +1671,7 @@
 	start_tx = sc->xl_cdata.xl_tx_free;
 
 	while(sc->xl_cdata.xl_tx_free != NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -1822,7 +1827,7 @@
 			break;
 		}
 
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -1990,7 +1995,11 @@
 	/*
 	 * Program the multicast filter, if necessary.
 	 */
+#if 0
 	if (sc->xl_type == XL_TYPE_905B)
+#else
+	if (0)	/* xl_setmulti_hash() does not work right */
+#endif
 		xl_setmulti_hash(sc);
 	else
 		xl_setmulti(sc);
@@ -2275,7 +2284,11 @@
 			 * Multicast list has changed; set the hardware
 			 * filter accordingly.
 			 */
+#if 0
 			if (sc->xl_type == XL_TYPE_905B)
+#else
+			if (0)	/* xl_setmulti_hash() does not work right */
+#endif
 				xl_setmulti_hash(sc);
 			else
 				xl_setmulti(sc);
@@ -2325,7 +2338,7 @@
 	xl_reset(sc, 0);
 	xl_init(sc);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		(*ifp->if_start)(ifp);
 
 	return;
@@ -2495,7 +2508,8 @@
 		ifp->if_start = xl_start;
 	ifp->if_watchdog = xl_watchdog;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = XL_TX_LIST_CNT - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, XL_TX_LIST_CNT - 1);
+	IFQ_SET_READY(&ifp->if_snd);
 	bcopy(sc->sc_dev.dv_xname, ifp->if_xname, IFNAMSIZ);
 
 	XL_SEL_WIN(3);
diff -urN ../sys/dev/pci/if_de.c ./dev/pci/if_de.c
--- ../sys/dev/pci/if_de.c	Sun Feb  4 07:56:53 2001
+++ ./dev/pci/if_de.c	Thu Jun 21 17:56:38 2001
@@ -4116,6 +4116,11 @@
     int segcnt, free;
     u_int32_t d_status;
     struct mbuf *m0;
+#if 1 /* ALTQ */
+    struct ifnet *ifp = &sc->tulip_if;
+    struct mbuf *ombuf = m;
+    int compressed = 0;
+#endif
 
 #if defined(TULIP_DEBUG)
     if ((sc->tulip_cmdmode & TULIP_CMD_TXRUN) == 0) {
@@ -4169,6 +4174,26 @@
 		 * entries that we can use for one packet, so we have
 		 * recopy it into one mbuf and then try again.
 		 */
+#if 1 /* ALTQ */
+		struct mbuf *tmp;
+		/*
+		 * tulip_mbuf_compress() frees the original mbuf.
+		 * thus, we have to remove the mbuf from the queue
+		 * before calling it.
+		 * we don't have to worry about space shortage
+		 * after compressing the mbuf since the compressed
+		 * mbuf will take only two segs.
+		 */
+		if (compressed) {
+		    /* should not happen */
+		    printf("tulip_txput: compress called twice!\n");
+		    goto finish;
+		}
+		IFQ_DEQUEUE(&ifp->if_snd, tmp);
+		if (tmp != ombuf)
+		    panic("tulip_txput: different mbuf dequeued!");
+		compressed = 1;
+#endif
 		m = tulip_mbuf_compress(m);
 		if (m == NULL)
 		    goto finish;
@@ -4235,6 +4260,16 @@
      * The descriptors have been filled in.  Now get ready
      * to transmit.
      */
+#if 1 /* ALTQ */
+    if (!compressed && (sc->tulip_flags & TULIP_TXPROBE_ACTIVE) == 0) {
+	/* remove the mbuf from the queue */
+	struct mbuf *tmp;
+	IFQ_DEQUEUE(&ifp->if_snd, tmp);
+	if (tmp != ombuf)
+	    panic("tulip_txput: different mbuf dequeued!");
+    }
+#endif
+
     IF_ENQUEUE(&sc->tulip_txq, m);
     m = NULL;
 
@@ -4593,11 +4628,19 @@
     return error;
 }
 
+#if 1 /* ALTQ */
+/*
+ * the original dequeueing policy is dequeue-and-prepend if something
+ * goes wrong.  when altq is used, it is changed to peek-and-dequeue.
+ * the modification becomes a bit complicated since tulip_txput() might
+ * copy and modify the mbuf passed.
+ */
+#endif
 /*
  * These routines gets called at device spl (from ether_output).  This might
  * pose a problem for TULIP_USE_SOFTINTR if ether_output is called at
  * device spl from another driver.
-	 */
+ */
 
 static ifnet_ret_t
 tulip_ifstart(
@@ -4611,15 +4654,23 @@
 	if ((sc->tulip_flags & (TULIP_WANTSETUP|TULIP_TXPROBE_ACTIVE)) == TULIP_WANTSETUP)
 	    tulip_txput_setup(sc);
 
-	while (sc->tulip_if.if_snd.ifq_head != NULL) {
-	    struct mbuf *m;
-	    IF_DEQUEUE(&sc->tulip_if.if_snd, m);
-	    if ((m = tulip_txput(sc, m)) != NULL) {
-		IF_PREPEND(&sc->tulip_if.if_snd, m);
+	while (!IFQ_IS_EMPTY(&sc->tulip_if.if_snd)) {
+	    struct mbuf *m, *m0;
+	    IFQ_POLL(&sc->tulip_if.if_snd, m);
+	    if (m == NULL)
+		break;
+	    if ((m0 = tulip_txput(sc, m)) != NULL) {
+		if (m0 != m)
+		    /* should not happen */
+		    printf("tulip_if_start: txput failed!\n");
 		break;
 	    }
 	}
-	if (sc->tulip_if.if_snd.ifq_head == NULL)
+#ifdef ALTQ
+	if (0) /* don't switch to the one packet mode */
+#else
+	if (IFQ_IS_EMPTY(&sc->tulip_if.if_snd))
+#endif
 	    sc->tulip_if.if_start = tulip_ifstart_one;
     }
 
@@ -4634,11 +4685,13 @@
     tulip_softc_t * const sc = TULIP_IFP_TO_SOFTC(ifp);
 
     if ((sc->tulip_if.if_flags & IFF_RUNNING)
-	    && sc->tulip_if.if_snd.ifq_head != NULL) {
-	struct mbuf *m;
-	IF_DEQUEUE(&sc->tulip_if.if_snd, m);
-	if ((m = tulip_txput(sc, m)) != NULL)
-	    IF_PREPEND(&sc->tulip_if.if_snd, m);
+	    && !IFQ_IS_EMPTY(&sc->tulip_if.if_snd)) {
+	struct mbuf *m, *m0;
+	IFQ_POLL(&sc->tulip_if.if_snd, m);
+	if (m != NULL && (m0 = tulip_txput(sc, m)) != NULL)
+	    if (m0 != m)
+		/* should not happen */
+		printf("tulip_if_start_one: txput failed!\n");
     }
     TULIP_PERFEND(ifstart_one);
 }
@@ -4837,6 +4890,7 @@
 
     tulip_reset(sc);
 
+    IFQ_SET_READY(&ifp->if_snd);
 #if defined(__bsdi__) && _BSDI_VERSION >= 199510
     sc->tulip_pf = printf;
     TULIP_ETHER_IFATTACH(sc);
diff -urN ../sys/dev/pci/if_en_pci.c ./dev/pci/if_en_pci.c
--- ../sys/dev/pci/if_en_pci.c	Sat Apr  7 11:37:36 2001
+++ ./dev/pci/if_en_pci.c	Thu Jun 21 17:56:38 2001
@@ -77,6 +77,15 @@
  * local defines (PCI specific stuff)
  */
 
+#if !defined(MIDWAY_ENIONLY)
+static  void eni_get_macaddr __P((struct en_pci_softc *,
+		struct pci_attach_args *));
+#endif
+#if !defined(MIDWAY_ADPONLY)
+static  void adp_get_macaddr __P((struct en_pci_softc *,
+		struct pci_attach_args *));
+#endif
+
 /* 
  * address of config base memory address register in PCI config space
  * (this is card specific)
@@ -109,7 +118,7 @@
  * prototypes
  */
 
-#ifdef __BROKEN_INDIRECT_CONFIG
+#ifdef __OpenBSD__
 static	int en_pci_match __P((struct device *, void *, void *));
 #else
 static	int en_pci_match __P((struct device *, struct cfdata *, void *));
@@ -162,7 +171,7 @@
 static int en_pci_match(parent, match, aux)
 
 struct device *parent;
-#ifdef __BROKEN_INDIRECT_CONFIG
+#ifdef __OpenBSD__
 void *match;
 #else
 struct cfdata *match;
@@ -252,6 +261,7 @@
 
 #if !defined(MIDWAY_ENIONLY)
   if (sc->is_adaptec) {
+    adp_get_macaddr(scp, pa);
     sc->en_busreset = adp_busreset;
     adp_busreset(sc);
   }
@@ -259,6 +269,7 @@
 
 #if !defined(MIDWAY_ADPONLY)
   if (!sc->is_adaptec) {
+    eni_get_macaddr(scp, pa);
     sc->en_busreset = NULL;
     pci_conf_write(scp->en_pc, pa->pa_tag, EN_TONGA, 
 		  (TONGA_SWAP_DMA|TONGA_SWAP_WORD));
@@ -272,3 +283,140 @@
   en_attach(sc);
 
 }
+
+#if 0
+static void
+en_pci_shutdown(
+	int howto,
+	void *sc)
+{
+    struct en_pci_softc *psc = (struct en_pci_softc *)sc;
+    
+    en_reset(&psc->esc);
+    DELAY(10);
+}
+#endif
+
+#if !defined(MIDWAY_ENIONLY)
+
+#if defined(sparc) || defined(__FreeBSD__)
+#define bus_space_read_1(t, h, o) \
+  		((void)t, (*(volatile u_int8_t *)((h) + (o))))
+#endif
+
+static void 
+adp_get_macaddr(scp, pa)
+     struct en_pci_softc *scp;
+     struct pci_attach_args *pa;
+{
+  struct en_softc * sc = (struct en_softc *)scp;
+  int lcv;
+
+  for (lcv = 0; lcv < sizeof(sc->macaddr); lcv++)
+    sc->macaddr[lcv] = bus_space_read_1(sc->en_memt, sc->en_base,
+					MID_ADPMACOFF + lcv);
+}
+
+#endif /* MIDWAY_ENIONLY */
+
+#if !defined(MIDWAY_ADPONLY)
+
+/*
+ * Read station (MAC) address from serial EEPROM.
+ * derived from linux drivers/atm/eni.c by Werner Almesberger, EPFL LRC.
+ */
+#define EN_PROM_MAGIC  0x0c
+#define EN_PROM_DATA   0x02
+#define EN_PROM_CLK    0x01
+#define EN_ESI         64
+
+static void 
+eni_get_macaddr(scp, pa)
+  struct en_pci_softc *scp;
+  struct pci_attach_args *pa;
+{
+  struct en_softc *sc = (struct en_softc *)scp;
+  pci_chipset_tag_t id = scp->en_pc;
+  pcitag_t tag = pa->pa_tag;
+  int i, j, address, status;
+  u_int32_t data, t_data;
+  u_int8_t tmp;
+  
+  t_data = pci_conf_read(id, tag, EN_TONGA) & 0xffffff00;
+
+  data =  EN_PROM_MAGIC | EN_PROM_DATA | EN_PROM_CLK;
+  pci_conf_write(id, tag, EN_TONGA, data);
+
+  for (i = 0; i < sizeof(sc->macaddr); i ++){
+    /* start operation */
+    data |= EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data |= EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data &= ~EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data &= ~EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    /* send address with serial line */
+    address = ((i + EN_ESI) << 1) + 1;
+    for ( j = 7 ; j >= 0 ; j --){
+      data = (address >> j) & 1 ? data | EN_PROM_DATA :
+      data & ~EN_PROM_DATA;
+      pci_conf_write(id, tag, EN_TONGA, data);
+      data |= EN_PROM_CLK ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+      data &= ~EN_PROM_CLK ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+    }
+    /* get ack */
+    data |= EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data |= EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data = pci_conf_read(id, tag, EN_TONGA);
+    status = data & EN_PROM_DATA;
+    data &= ~EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data |= EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+
+    tmp = 0;
+
+    for ( j = 7 ; j >= 0 ; j --){
+      tmp <<= 1;
+      data |= EN_PROM_DATA ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+      data |= EN_PROM_CLK ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+      data = pci_conf_read(id, tag, EN_TONGA);
+      if(data & EN_PROM_DATA) tmp |= 1;
+      data &= ~EN_PROM_CLK ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+      data |= EN_PROM_DATA ;
+      pci_conf_write(id, tag, EN_TONGA, data);
+    }
+    /* get ack */
+    data |= EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data |= EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data = pci_conf_read(id, tag, EN_TONGA);
+    status = data & EN_PROM_DATA;
+    data &= ~EN_PROM_CLK ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+    data |= EN_PROM_DATA ;
+    pci_conf_write(id, tag, EN_TONGA, data);
+
+    sc->macaddr[i] = tmp;
+  }
+  /* stop operation */
+  data &=  ~EN_PROM_DATA;
+  pci_conf_write(id, tag, EN_TONGA, data);
+  data |=  EN_PROM_CLK;
+  pci_conf_write(id, tag, EN_TONGA, data);
+  data |=  EN_PROM_DATA;
+  pci_conf_write(id, tag, EN_TONGA, data);
+  pci_conf_write(id, tag, EN_TONGA, t_data);
+}
+
+#endif /* !MIDWAY_ADPONLY */
diff -urN ../sys/dev/pci/if_lmc.c ./dev/pci/if_lmc.c
--- ../sys/dev/pci/if_lmc.c	Thu Apr 27 09:32:09 2000
+++ ./dev/pci/if_lmc.c	Thu Jun 21 17:56:38 2001
@@ -1286,15 +1286,20 @@
 lmc_ifstart(struct ifnet * const ifp)
 {
 	lmc_softc_t * const sc = LMC_IFP_TO_SOFTC(ifp);
-	struct mbuf *m;
+	struct mbuf *m, *m0;
 
 	if (sc->lmc_flags & LMC_IFUP) {
 		while (sppp_isempty(ifp) == 0) {
-			m = sppp_dequeue(ifp);
-			if ((m = lmc_txput(sc, m)) != NULL) {
-				IF_PREPEND(&((struct sppp *)ifp)->pp_fastq, m);
+			m = sppp_pick(ifp);
+			if (m == NULL)
+				break;
+			if ((m = lmc_txput(sc, m)) != NULL)
 				break;
-			}
+			m0 = sppp_dequeue(ifp);
+#if defined(LMC_DEBUG)
+			if (m0 != m)
+				printf("lmc_ifstart: mbuf mismatch!\n");
+#endif
 		}
 		LMC_CSR_WRITE(sc, csr_txpoll, 1);
 	}
@@ -1304,13 +1309,17 @@
 lmc_ifstart_one(struct ifnet * const ifp)
 {
 	lmc_softc_t * const sc = LMC_IFP_TO_SOFTC(ifp);
-	struct mbuf *m;
+	struct mbuf *m, *m0;
 
 	if ((sc->lmc_flags & LMC_IFUP) && (sppp_isempty(ifp) == 0)) {
-		m = sppp_dequeue(ifp);
-		if ((m = lmc_txput(sc, m)) != NULL) {
-			IF_PREPEND(&((struct sppp *)ifp)->pp_fastq, m);
-		}
+		m = sppp_pick(ifp);
+		if ((m = lmc_txput(sc, m)) != NULL)
+			return;
+		m0 = sppp_dequeue(ifp);
+#if defined(LMC_DEBUG)
+		if (m0 != m)
+			printf("lmc_ifstart: mbuf mismatch!\n");
+#endif
 		LMC_CSR_WRITE(sc, csr_txpoll, 1);
 	}
 }
@@ -1428,6 +1437,7 @@
 	ifp->if_watchdog = lmc_watchdog;
 	ifp->if_timer = 1;
 	ifp->if_mtu = LMC_MTU;
+	IFQ_SET_READY(&ifp->if_snd);
 
 #if defined(__bsdi__)
 	ifp->if_type = IFT_NONE;
diff -urN ../sys/dev/pci/if_ti.c ./dev/pci/if_ti.c
--- ../sys/dev/pci/if_ti.c	Wed Apr  4 05:44:43 2001
+++ ./dev/pci/if_ti.c	Thu Jun 21 17:56:48 2001
@@ -1683,7 +1683,8 @@
 	ifp->if_start = ti_start;
 	ifp->if_watchdog = ti_watchdog;
 	ifp->if_mtu = ETHERMTU;
-	ifp->if_snd.ifq_maxlen = TI_TX_RING_CNT - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, TI_TX_RING_CNT - 1);
+	IFQ_SET_READY(&ifp->if_snd);
 	bcopy(sc->sc_dv.dv_xname, ifp->if_xname, IFNAMSIZ);
 
 	/* Set up ifmedia support. */
@@ -1946,7 +1947,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_4(sc, TI_MB_HOSTINTR, 0);
 
-	if (ifp->if_flags & IFF_RUNNING && ifp->if_snd.ifq_head != NULL)
+	if (ifp->if_flags & IFF_RUNNING && !IFQ_IS_EMPTY(&ifp->if_snd))
 		ti_start(ifp);
 
 	return (1);
@@ -2070,13 +2071,14 @@
 	struct ti_softc		*sc;
 	struct mbuf		*m_head = NULL;
 	u_int32_t		prodidx = 0;
+	int			pkts = 0;
 
 	sc = ifp->if_softc;
 
 	prodidx = CSR_READ_4(sc, TI_MB_SENDPROD_IDX);
 
 	while(sc->ti_cdata.ti_tx_chain[prodidx] == NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_POLL(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -2086,11 +2088,14 @@
 		 * for the NIC to drain the ring.
 		 */
 		if (ti_encap(sc, m_head, &prodidx)) {
-			IF_PREPEND(&ifp->if_snd, m_head);
 			ifp->if_flags |= IFF_OACTIVE;
 			break;
 		}
 
+		/* now we are committed to transmit the packet */
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
+		pkts++;
+
 		/*
 		 * If there's a BPF listener, bounce a copy of this frame
 		 * to him.
@@ -2100,6 +2105,8 @@
 			bpf_mtap(ifp->if_bpf, m_head);
 #endif
 	}
+	if (pkts == 0)
+		return;
 
 	/* Transmit */
 	CSR_WRITE_4(sc, TI_MB_SENDPROD_IDX, prodidx);
diff -urN ../sys/dev/pci/if_tl.c ./dev/pci/if_tl.c
--- ../sys/dev/pci/if_tl.c	Fri Apr  6 05:13:47 2001
+++ ./dev/pci/if_tl.c	Thu Jun 21 18:05:07 2001
@@ -1395,7 +1395,7 @@
 		CMD_PUT(sc, TL_CMD_ACK | r | type);
 	}
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		tl_start(ifp);
 
 	return r;
@@ -1571,7 +1571,7 @@
 	start_tx = sc->tl_cdata.tl_tx_free;
 
 	while(sc->tl_cdata.tl_tx_free != NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -2154,7 +2154,8 @@
 	ifp->if_start = tl_start;
 	ifp->if_watchdog = tl_watchdog;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = TL_TX_LIST_CNT - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, TL_TX_LIST_CNT - 1);
+	IFQ_SET_READY(&ifp->if_snd);
 	bcopy(sc->sc_dev.dv_xname, ifp->if_xname, IFNAMSIZ);
 
 	/*
diff -urN ../sys/dev/pci/if_tx.c ./dev/pci/if_tx.c
--- ../sys/dev/pci/if_tx.c	Wed Apr  4 05:44:43 2001
+++ ./dev/pci/if_tx.c	Thu Jun 21 17:56:48 2001
@@ -447,7 +447,8 @@
 	ifp->if_init = (if_init_f_t*)epic_init;
 	ifp->if_timer = 0;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = TX_RING_SIZE - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, TX_RING_SIZE - 1);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	/* Enable ports, memory and busmastering */
 	command = pci_read_config(dev, PCIR_COMMAND, 4);
@@ -819,7 +820,7 @@
 		flist = sc->tx_flist + sc->cur_tx;
 
 		/* Get next packet to send */
-		IF_DEQUEUE( &ifp->if_snd, m0 );
+		IFQ_DEQUEUE( &ifp->if_snd, m0 );
 
 		/* If nothing to send, return */
 		if( NULL == m0 ) return;
@@ -1038,7 +1039,7 @@
         if( status & (INTSTAT_TXC|INTSTAT_TCC|INTSTAT_TQE) ) {
             epic_tx_done( sc );
 	    if(!(sc->sc_if.if_flags & IFF_OACTIVE) &&
-		sc->sc_if.if_snd.ifq_head )
+		!IFQ_IS_EMPTY( &sc->sc_if.if_snd ))
 		    epic_ifstart( &sc->sc_if );
 	}
 
@@ -1128,7 +1129,7 @@
 		printf("seems we can continue normaly\n");
 
 	/* Start output */
-	if( ifp->if_snd.ifq_head ) epic_ifstart( ifp );
+	if( !IFQ_IS_EMPTY( &ifp->if_snd ) ) epic_ifstart( ifp );
 
 	splx(x);
 }
diff -urN ../sys/dev/pci/if_vr.c ./dev/pci/if_vr.c
--- ../sys/dev/pci/if_vr.c	Wed Apr  4 05:44:43 2001
+++ ./dev/pci/if_vr.c	Thu Jun 21 17:56:48 2001
@@ -759,6 +759,7 @@
 	ifp->if_start = vr_start;
 	ifp->if_watchdog = vr_watchdog;
 	ifp->if_baudrate = 10000000;
+	IFQ_SET_READY(&ifp->if_snd);
 	bcopy(sc->sc_dev.dv_xname, ifp->if_xname, IFNAMSIZ);
 
 	/*
@@ -1181,7 +1182,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_2(sc, VR_IMR, VR_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL) {
+	if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 		vr_start(ifp);
 	}
 
@@ -1287,7 +1288,7 @@
 	start_tx = sc->vr_cdata.vr_tx_free;
 
 	while(sc->vr_cdata.vr_tx_free->vr_mbuf == NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -1538,7 +1539,7 @@
 	vr_reset(sc);
 	vr_init(sc);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		vr_start(ifp);
 
 	return;
diff -urN ../sys/dev/pci/if_wb.c ./dev/pci/if_wb.c
--- ../sys/dev/pci/if_wb.c	Wed Feb 21 07:29:58 2001
+++ ./dev/pci/if_wb.c	Thu Jun 21 17:56:48 2001
@@ -903,7 +903,9 @@
 	ifp->if_start = wb_start;
 	ifp->if_watchdog = wb_watchdog;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = WB_TX_LIST_CNT - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, WB_TX_LIST_CNT - 1);
+	IFQ_SET_READY(&ifp->if_snd);
+
 	bcopy(sc->sc_dev.dv_xname, ifp->if_xname, IFNAMSIZ);
 
 	/*
@@ -1310,7 +1312,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_4(sc, WB_IMR, WB_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL) {
+	if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 		wb_start(ifp);
 	}
 
@@ -1449,7 +1451,7 @@
 	start_tx = sc->wb_cdata.wb_tx_free;
 
 	while(sc->wb_cdata.wb_tx_free->wb_mbuf == NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_DEQUEUE(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
@@ -1752,7 +1754,7 @@
 	wb_reset(sc);
 	wb_init(sc);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		wb_start(ifp);
 
 	return;
diff -urN ../sys/dev/pcmcia/if_wi.c ./dev/pcmcia/if_wi.c
--- ../sys/dev/pcmcia/if_wi.c	Tue Apr 24 06:18:48 2001
+++ ./dev/pcmcia/if_wi.c	Thu Jun 21 17:56:48 2001
@@ -422,7 +422,8 @@
 	ifp->if_start = wi_start;
 	ifp->if_watchdog = wi_watchdog;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	bzero(sc->wi_node_name, sizeof(sc->wi_node_name));
 	bcopy(WI_DEFAULT_NODENAME, sc->wi_node_name,
@@ -612,7 +613,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_2(sc, WI_INT_EN, WI_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		wi_start(ifp);
 
 	return (1);
@@ -1568,7 +1569,7 @@
 	if (ifp->if_flags & IFF_OACTIVE)
 		return;
 
-	IF_DEQUEUE(&ifp->if_snd, m0);
+	IFQ_DEQUEUE(&ifp->if_snd, m0);
 	if (m0 == NULL)
 		return;
 
diff -urN ../sys/net/if.c ./net/if.c
--- ../sys/net/if.c	Wed Feb 21 07:30:22 2001
+++ ./net/if.c	Thu Jun 21 17:56:48 2001
@@ -244,6 +244,13 @@
 	sdl->sdl_len = masklen;
 	while (namelen != 0)
 		sdl->sdl_data[--namelen] = 0xff;
+#ifdef ALTQ
+	ifp->if_snd.altq_type = 0;
+	ifp->if_snd.altq_disc = NULL;
+	ifp->if_snd.altq_flags &= ALTQF_CANTCHANGE;
+	ifp->if_snd.altq_tbr  = NULL;
+	ifp->if_snd.altq_ifp  = ifp;
+#endif
 }
 
 void
@@ -350,6 +357,12 @@
 	if (ifp->if_bpf)
 		bpfdetach(ifp);
 #endif
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(&ifp->if_snd))
+		altq_disable(&ifp->if_snd);
+	if (ALTQ_IS_ATTACHED(&ifp->if_snd))
+		altq_detach(&ifp->if_snd);
+#endif
 
 	/*
 	 * Find and remove all routes which is using this interface.
@@ -593,7 +606,7 @@
 	ifp->if_flags &= ~IFF_UP;
 	for (ifa = ifp->if_addrlist.tqh_first; ifa != 0; ifa = ifa->ifa_list.tqe_next)
 		pfctlinput(PRC_IFDOWN, ifa->ifa_addr);
-	if_qflush(&ifp->if_snd);
+	IFQ_PURGE(&ifp->if_snd);
 	rt_ifmsg(ifp);
 
 	/*
diff -urN ../sys/net/if.h ./net/if.h
--- ../sys/net/if.h	Tue Feb  6 21:33:36 2001
+++ ./net/if.h	Thu Jun 21 17:56:48 2001
@@ -37,6 +37,9 @@
  */
 
 #include <sys/queue.h>
+#if 1 /* ALTQ */
+#include <altq/if_altq.h>
+#endif
 
 /*
  * Structures defining a network interface, providing a packet
@@ -102,6 +105,17 @@
 };
 
 /*
+ * Structure defining a queue for a network interface.
+ */
+struct	ifqueue {
+	struct	mbuf *ifq_head;
+	struct	mbuf *ifq_tail;
+	int	ifq_len;
+	int	ifq_maxlen;
+	int	ifq_drops;
+};
+
+/*
  * Values for if_link_state.
  */
 #define	LINK_STATE_UNKNOWN	0	/* link invalid/unknown */
@@ -146,13 +160,11 @@
 		__P((struct ifnet *));
 	void	(*if_watchdog)		/* timer routine */
 		__P((struct ifnet *));
-	struct	ifqueue {
-		struct	mbuf *ifq_head;
-		struct	mbuf *ifq_tail;
-		int	ifq_len;
-		int	ifq_maxlen;
-		int	ifq_drops;
-	} if_snd;			/* output queue */
+#if 1 /* ALTQ */
+	struct	ifaltq if_snd;		/* output queue (includes altq) */
+#else
+	struct	ifqueue if_snd;		/* output queue */
+#endif
 	struct ifprefix *if_prefixlist; /* linked list of prefixes per if */
 };
 #define	if_mtu		if_data.ifi_mtu
@@ -238,6 +250,17 @@
 		(ifq)->ifq_len--; \
 	} \
 }
+#define	IF_POLL(ifq, m)		((m) = (ifq)->ifq_head)
+#define	IF_PURGE(ifq)							\
+while (1) {								\
+	struct mbuf *m0;						\
+	IF_DEQUEUE((ifq), m0);						\
+	if (m0 == NULL)							\
+		break;							\
+	else								\
+		m_freem(m0);						\
+}
+#define	IF_IS_EMPTY(ifq)	((ifq)->ifq_len == 0)
 
 #define	IFQ_MAXLEN	50
 #define	IFNET_SLOWHZ	1		/* granularity is 1 second */
@@ -402,6 +425,107 @@
 	else \
 		(ifa)->ifa_refcnt--; \
 } while (0)
+
+#ifdef ALTQ
+
+#define	IFQ_ENQUEUE(ifq, m, pattr, err)					\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq)))					\
+		ALTQ_ENQUEUE((ifq), (m), (pattr), (err));		\
+	else {								\
+		if (IF_QFULL((ifq))) {					\
+			m_freem((m));					\
+			(err) = ENOBUFS;				\
+		} else {						\
+			IF_ENQUEUE((ifq), (m));				\
+			(err) = 0;					\
+		}							\
+	}								\
+	if ((err))							\
+		(ifq)->ifq_drops++;					\
+} while (0)
+
+#define	IFQ_DEQUEUE(ifq, m)						\
+do {									\
+	if (TBR_IS_ENABLED((ifq)))					\
+		(m) = tbr_dequeue((ifq), ALTDQ_REMOVE);			\
+	else if (ALTQ_IS_ENABLED((ifq)))				\
+		ALTQ_DEQUEUE((ifq), (m));				\
+	else								\
+		IF_DEQUEUE((ifq), (m));					\
+} while (0)
+
+#define	IFQ_POLL(ifq, m)						\
+do {									\
+	if (TBR_IS_ENABLED((ifq)))					\
+		(m) = tbr_dequeue((ifq), ALTDQ_POLL);			\
+	else if (ALTQ_IS_ENABLED((ifq)))				\
+		ALTQ_POLL((ifq), (m));					\
+	else								\
+		IF_POLL((ifq), (m));					\
+} while (0)
+
+#define	IFQ_PURGE(ifq)							\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq)))					\
+		ALTQ_PURGE((ifq));					\
+	else								\
+		IF_PURGE((ifq));					\
+} while (0)
+
+#define	IFQ_SET_READY(ifq)						\
+	do { ((ifq)->altq_flags |= ALTQF_READY); } while (0)
+
+#define	IFQ_CLASSIFY(ifq, m, af, pa)					\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq))) {					\
+		if (ALTQ_NEEDS_CLASSIFY((ifq)))				\
+			(pa)->pattr_class = (*(ifq)->altq_classify)	\
+				((ifq)->altq_clfier, (m), (af));	\
+		(pa)->pattr_af = (af);					\
+		(pa)->pattr_hdr = mtod((m), caddr_t);			\
+	}								\
+} while (0)
+
+#else /* !ALTQ */
+
+#define	IFQ_ENQUEUE(ifq, m, err)					\
+do {									\
+	if (IF_QFULL((ifq))) {						\
+		m_freem((m));						\
+		(err) = ENOBUFS;					\
+	} else {							\
+		IF_ENQUEUE((ifq), (m));					\
+		(err) = 0;						\
+	}								\
+	if ((err))							\
+		(ifq)->ifq_drops++;					\
+} while (0)
+
+#define	IFQ_DEQUEUE(ifq, m)	IF_DEQUEUE((ifq), (m))
+
+#define	IFQ_POLL(ifq, m)	IF_POLL((ifq), (m))
+
+#define	IFQ_PURGE(ifq)							\
+while (1) {								\
+	struct mbuf *m0;						\
+	IF_DEQUEUE((ifq), m0);						\
+	if (m0 == NULL)							\
+		break;							\
+	else								\
+		m_freem(m0);						\
+}
+
+#define	IFQ_SET_READY(ifq)		((void)0)
+#define	IFQ_CLASSIFY(ifq, m, af, pa)	((void)0)
+
+#endif /* !ALTQ */
+
+#define	IFQ_IS_EMPTY(ifq)		((ifq)->ifq_len == 0)
+#define	IFQ_INC_LEN(ifq)		((ifq)->ifq_len++)
+#define	IFQ_DEC_LEN(ifq)		(--(ifq)->ifq_len)
+#define	IFQ_INC_DROPS(ifq)		((ifq)->ifq_drops++)
+#define	IFQ_SET_MAXLEN(ifq, len)	((ifq)->ifq_maxlen = (len))
 
 struct ifnet_head ifnet;
 struct ifnet **ifindex2ifnet;
